/*
    Copyright (C) 2010  NOP Security

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

unsigned char AsciiToSpecialMap[]={ // Should be 0x00-0x4A (-30h from ASCII)
0x00,		//Ascii 0x30 '0' - NULL
0x3A,		//Ascii 0x31 '1' - F1
0x3B,		//Ascii 0x32 '2' - F2
0x3C,		//Ascii 0x33 '3' - F3
0x3D,		//Ascii 0x34 '4' - F4
0x3E,		//Ascii 0x35 '5' - F5
0x3F,		//Ascii 0x36 '6' - F6
0x40,		//Ascii 0x37 '7' - F7
0x41,		//Ascii 0x38 '8' - F8
0x42,		//Ascii 0x39 '9' - F9
0x7C,		//Ascii 0x3A ':' - COPY*
0x7D,		//Ascii 0x3B ';' - PASTE*
0x50,		//Ascii 0x3C '<' - LEFT ARROW
0xA1,		//Ascii 0x3D '=' - OPER*
0x4F,		//Ascii 0x3E '>' - RIGHT ARROW
0x9A,		//Ascii 0x3F '?' - SYSREQ/ATTENTION*
0x65,		//Ascii 0x40 '@' - APPLICATION
0x43,		//Ascii 0x41 'A' - F10
0x44,		//Ascii 0x42 'B' - F11
0x45,		//Ascii 0x43 'C' - F12
0x4C,		//Ascii 0x44 'D' - DEL
0x29,		//Ascii 0x45 'E' - ESC
0x7E,		//Ascii 0x46 'F' - FIND*
0x79,		//Ascii 0x47 'G' - AGAIN*
0x4A,		//Ascii 0x48 'H' - HOME
0x49,		//Ascii 0x49 'I' - INSERT
0x01,		//Ascii 0x4A 'J' - ERROR_ROLL_OVER_KB_ERROR
0x39,		//Ascii 0x4B 'K' - CAPS
0x47,		//Ascii 0x4C 'L' - SCROLL LOCK
0x7F,		//Ascii 0x4D 'M' - MUTE*
0x53,		//Ascii 0x4E 'N' - NUM LOCK/CLEAR
0x66,		//Ascii 0x4F 'O' - POWER*
0x46,		//Ascii 0x50 'P' - PRINT SCREEN
0x02,		//Ascii 0x51 'Q' - ERROR_POST_FAIL_KB_ERROR
0x58,		//Ascii 0x52 'R' - KEYPAD ENTER
0x48,		//Ascii 0x53 'S' - PAUSE
0x2B,		//Ascii 0x54 'T' - TAB
0x4B,		//Ascii 0x55 'U' - PAGE UP
0x4E,		//Ascii 0x56 'V' - PAGE DOWN
0x4D,		//Ascii 0x57 'W' - END
0x2A,		//Ascii 0x58 'X' - BACKSPACE
0x03,		//Ascii 0x59 'Y' - UNDEFINED_ERROR_KB_ERROR
0x7A,		//Ascii 0x5A 'Z' - UNDO*
0x68,		//Ascii 0x5B '[' - F13*
0x69,		//Ascii 0x5C '\' - F14*
0x6A,		//Ascii 0x5D ']' - F15*
0x52,		//Ascii 0x5E '^' - UP ARROW
0x51,		//Ascii 0x5F '_' - DOWN ARROW
0x9B,		//Ascii 0x60 '`' - CANCEL*
0x43,		//Ascii 0x61 'A' - F10  *** Below are duplicates for lower case ***
0x44,		//Ascii 0x62 'B' - F11
0x45,		//Ascii 0x63 'C' - F12
0x4C,		//Ascii 0x64 'D' - DEL
0x29,		//Ascii 0x65 'E' - ESC
0x7E,		//Ascii 0x66 'F' - FIND
0x79,		//Ascii 0x67 'G' - AGAIN
0x4A,		//Ascii 0x68 'H' - HOME
0x49,		//Ascii 0x69 'I' - INSERT
0x01,		//Ascii 0x6A 'J' - ERROR_ROLL_OVER_KB_ERROR
0x39,		//Ascii 0x6B 'K' - CAPS
0x47,		//Ascii 0x6C 'L' - SCROLL LOCK
0x7F,		//Ascii 0x6D 'M' - MUTE
0x53,		//Ascii 0x6E 'N' - NUM LOCK/CLEAR
0x66,		//Ascii 0x6F 'O' - POWER
0x46,		//Ascii 0x70 'P' - PRINT SCREEN
0x02,		//Ascii 0x71 'Q' - ERROR_POST_FAIL_KB_ERROR
0x58,		//Ascii 0x72 'R' - KEYPAD ENTER
0x48,		//Ascii 0x73 'S' - PAUSE
0x2B,		//Ascii 0x74 'T' - TAB
0x4B,		//Ascii 0x75 'U' - PAGE UP
0x4E,		//Ascii 0x76 'V' - PAGE DOWN
0x4D,		//Ascii 0x77 'W' - END
0x2A,		//Ascii 0x78 'X' - BACKSPACE
0x03,		//Ascii 0x79 'Y' - UNDEFINED_ERROR_KB_ERROR
0x7A		//Ascii 0x7A 'Z' - UNDO
};

unsigned char AsciiToScancodeMap[]={
0x00, 0x00,		//Ascii 0x00 NULL
0x00, 0x00,		//Ascii 0x01
0x00, 0x00,		//Ascii 0x02
0x00, 0x00,		//Ascii 0x03
0x00, 0x00,		//Ascii 0x04
0x00, 0x00,		//Ascii 0x05
0x00, 0x00,		//Ascii 0x06
0x00, 0x00,		//Ascii 0x07
0x00, 0x00,		//Ascii 0x08
0x00, 0x2B,		//Ascii 0x09 TAB
0x00, 0x28,		//Ascii 0x0A LF
0x00, 0x00,		//Ascii 0x0B
0x00, 0x00,		//Ascii 0x0C
0x00, 0x00,		//Ascii 0x0D CR
0x00, 0x00,		//Ascii 0x0E
0x00, 0x00,		//Ascii 0x0F
0x00, 0x00,		//Ascii 0x10
0x00, 0x00,		//Ascii 0x11
0x00, 0x00,		//Ascii 0x12
0x00, 0x00,		//Ascii 0x13
0x00, 0x00,		//Ascii 0x14
0x00, 0x00,		//Ascii 0x15
0x00, 0x00,		//Ascii 0x16
0x00, 0x00,		//Ascii 0x17
0x00, 0x00,		//Ascii 0x18
0x00, 0x00,		//Ascii 0x19
0x00, 0x00,		//Ascii 0x1A
0x00, 0x29,		//Ascii 0x1B ESC
0x00, 0x00,		//Ascii 0x1C
0x00, 0x00,		//Ascii 0x1D
0x00, 0x00,		//Ascii 0x1E
0x00, 0x00,		//Ascii 0x1F
0x00, 0x2C,		//Ascii 0x20 ' '
0x02, 0x1E,		//Ascii 0x21 '!'
0x02, 0x34,		//Ascii 0x22 '"'
0x02, 0x20,		//Ascii 0x23 '#'
0x02, 0x21,		//Ascii 0x24 '$'
0x02, 0x22,		//Ascii 0x25 '%'
0x02, 0x24,		//Ascii 0x26 '&'
0x00, 0x34,		//Ascii 0x27 '''
0x02, 0x26,		//Ascii 0x28 '('
0x02, 0x27,		//Ascii 0x29 ')'
0x02, 0x25,		//Ascii 0x2A '*'
0x02, 0x2E,		//Ascii 0x2B '+'
0x00, 0x36,		//Ascii 0x2C ','
0x00, 0x2D,		//Ascii 0x2D '-'
0x00, 0x37,		//Ascii 0x2E '.'
0x00, 0x38,		//Ascii 0x2F '/'
0x00, 0x27,		//Ascii 0x30 '0'
0x00, 0x1E,		//Ascii 0x31 '1'
0x00, 0x1F,		//Ascii 0x32 '2'
0x00, 0x20,		//Ascii 0x33 '3'
0x00, 0x21,		//Ascii 0x34 '4'
0x00, 0x22,		//Ascii 0x35 '5'
0x00, 0x23,		//Ascii 0x36 '6'
0x00, 0x24,		//Ascii 0x37 '7'
0x00, 0x25,		//Ascii 0x38 '8'
0x00, 0x26,		//Ascii 0x39 '9'
0x02, 0x33,		//Ascii 0x3A ':'
0x00, 0x33,		//Ascii 0x3B ';'
0x02, 0x36,		//Ascii 0x3C '<'
0x00, 0x2E,		//Ascii 0x3D '='
0x02, 0x37,		//Ascii 0x3E '>'
0x02, 0x38,		//Ascii 0x3F '?'
0x02, 0x1F,		//Ascii 0x40 '@'
0x02, 0x04,		//Ascii 0x41 'A'
0x02, 0x05,		//Ascii 0x42 'B'
0x02, 0x06,		//Ascii 0x43 'C'
0x02, 0x07,		//Ascii 0x44 'D'
0x02, 0x08,		//Ascii 0x45 'E'
0x02, 0x09,		//Ascii 0x46 'F'
0x02, 0x0A,		//Ascii 0x47 'G'
0x02, 0x0B,		//Ascii 0x48 'H'
0x02, 0x0C,		//Ascii 0x49 'I'
0x02, 0x0D,		//Ascii 0x4A 'J'
0x02, 0x0E,		//Ascii 0x4B 'K'
0x02, 0x0F,		//Ascii 0x4C 'L'
0x02, 0x10,		//Ascii 0x4D 'M'
0x02, 0x11,		//Ascii 0x4E 'N'
0x02, 0x12,		//Ascii 0x4F 'O'
0x02, 0x13,		//Ascii 0x50 'P'
0x02, 0x14,		//Ascii 0x51 'Q'
0x02, 0x15,		//Ascii 0x52 'R'
0x02, 0x16,		//Ascii 0x53 'S'
0x02, 0x17,		//Ascii 0x54 'T'
0x02, 0x18,		//Ascii 0x55 'U'
0x02, 0x19,		//Ascii 0x56 'V'
0x02, 0x1A,		//Ascii 0x57 'W'
0x02, 0x1B,		//Ascii 0x58 'X'
0x02, 0x1C,		//Ascii 0x59 'Y'
0x02, 0x1D,		//Ascii 0x5A 'Z'
0x00, 0x2F,		//Ascii 0x5B '['
0x00, 0x31,		//Ascii 0x5C '\'
0x00, 0x30,		//Ascii 0x5D ']'
0x02, 0x23,		//Ascii 0x5E '^'
0x02, 0x2D,		//Ascii 0x5F '_'
0x00, 0x35,		//Ascii 0x60 '`'
0x00, 0x04,		//Ascii 0x61 'a'
0x00, 0x05,		//Ascii 0x62 'b'
0x00, 0x06,		//Ascii 0x63 'c'
0x00, 0x07,		//Ascii 0x64 'd'
0x00, 0x08,		//Ascii 0x65 'e'
0x00, 0x09,		//Ascii 0x66 'f'
0x00, 0x0A,		//Ascii 0x67 'g'
0x00, 0x0B,		//Ascii 0x68 'h'
0x00, 0x0C,		//Ascii 0x69 'i'
0x00, 0x0D,		//Ascii 0x6A 'j'
0x00, 0x0E,		//Ascii 0x6B 'k'
0x00, 0x0F,		//Ascii 0x6C 'l'
0x00, 0x10,		//Ascii 0x6D 'm'
0x00, 0x11,		//Ascii 0x6E 'n'
0x00, 0x12,		//Ascii 0x6F 'o'
0x00, 0x13,		//Ascii 0x70 'p'
0x00, 0x14,		//Ascii 0x71 'q'
0x00, 0x15,		//Ascii 0x72 'r'
0x00, 0x16,		//Ascii 0x73 's'
0x00, 0x17,		//Ascii 0x74 't'
0x00, 0x18,		//Ascii 0x75 'u'
0x00, 0x19,		//Ascii 0x76 'v'
0x00, 0x1A,		//Ascii 0x77 'w'
0x00, 0x1B,		//Ascii 0x78 'x'
0x00, 0x1C,		//Ascii 0x79 'y'
0x00, 0x1D,		//Ascii 0x7A 'z'
0x02, 0x2F,		//Ascii 0x7B '{'
0x02, 0x31,		//Ascii 0x7C '|'
0x02, 0x30,		//Ascii 0x7D '}'
0x02, 0x35,		//Ascii 0x7E '~'
0x00, 0x00		//Ascii 0x7F ''
};

wchar_t SpecialMapDescrip[]= L"\
Type something in to add keystrokes. Special characters must be prefixed with ~.\r\n\
Code list:\r\n\
0 - NULL\r\n\
1 - F1\r\n\
2 - F2\r\n\
3 - F3\r\n\
4 - F4\r\n\
5 - F5\r\n\
6 - F6\r\n\
7 - F7\r\n\
8 - F8\r\n\
9 - F9\r\n\
: - COPY*\r\n\
; - PASTE*\r\n\
< - LEFT ARROW\r\n\
= - OPER*\r\n\
> - RIGHT ARROW\r\n\
? - SYSREQ/ATTENTION*\r\n\
@ - APPLICATION\r\n\
A - F10\r\n\
B - F11\r\n\
C - F12\r\n\
D - DEL\r\n\
E - ESC\r\n\
F - FIND*\r\n\
G - AGAIN*\r\n\
H - HOME\r\n\
I - INSERT\r\n\
J - ERROR_ROLL_OVER_KB_ERROR\r\n\
K - CAPS\r\n\
L - SCROLL LOCK\r\n\
M - MUTE*\r\n\
N - NUM LOCK/CLEAR\r\n\
O - POWER*\r\n\
P - PRINT SCREEN\r\n\
Q - ERROR_POST_FAIL_KB_ERROR\r\n\
R - KEYPAD ENTER\r\n\
S - PAUSE\r\n\
T - TAB\r\n\
U - PAGE UP\r\n\
V - PAGE DOWN\r\n\
W - END\r\n\
X - BACKSPACE\r\n\
Y - UNDEFINED_ERROR_KB_ERROR\r\n\
Z - UNDO*\r\n\
[ - F13*\r\n\
\\ - F14*\r\n\
] - F15*\r\n\
^ - UP ARROW\r\n\
_ - DOWN ARROW\r\n\
` - CANCEL*\r\n\
~ - ~\r\n\
* Marked entries are above key 101 and may not be compatible with some systems.\r\n";


wchar_t ModsDescrip[]= L"\
Modifiers are written as 1 hex byte:\r\n\
Bit 0 (0x01): LeftControl\r\n\
Bit 1 (0x02): LeftShift\r\n\
Bit 2 (0x04): LeftAlt\r\n\
Bit 3 (0x08): Left GUI\r\n\
Bit 4 (0x10): RightControl\r\n\
Bit 5 (0x20): RightShift\r\n\
Bit 6 (0x40): RightAlt\r\n\
Bit 7 (0x80): Right GUI\r\n";
